Package ghidra.program.model.block

# Class SimpleDestReferenceIterator

java.lang.Object
ghidra.program.model.block.SimpleDestReferenceIterator

All Implemented Interfaces:
  `CodeBlockReferenceIterator`

public class SimpleDestReferenceIterator extends Object implements CodeBlockReferenceIterator
This iterator is implemented by getting the flows from the instruction and iterating over those flows (plus the fallthrough). This is probably not the most efficient method. An linked-list of references has to be created each time we want to get the destinations from a block.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SimpleDestReferenceIterator(CodeBlock block, boolean followIndirectFlows, TaskMonitor monitor)`
  Construct an Iterator over Destination blocks for a CodeBlock.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `getNumDestinations(CodeBlock block, boolean followIndirectFlows, TaskMonitor monitor)`
  Deprecated.
  this method should be avoided since it repeats the work of the iterator
  `boolean`
  `hasNext()`
  Return true if next() will return a CodeBlockReference.
  `CodeBlockReference`
  `next()`
  Return the next CodeBlockReference.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SimpleDestReferenceIterator

    public SimpleDestReferenceIterator(CodeBlock block, boolean followIndirectFlows, TaskMonitor monitor) throws CancelledException
    Construct an Iterator over Destination blocks for a CodeBlock. External references are ignored.
    Parameters:
      `block` - block to get destination blocks for. This should be a block obtained from SimpleBlockModel.
      `followIndirectFlows` - indirect references will only be included if true
      `monitor` - task monitor which allows user to cancel operation.
    Throws:
      `CancelledException` - if the monitor cancels the operation.

- ## Method Details

  - ### next

    public CodeBlockReference next() throws CancelledException
    Description copied from interface: `CodeBlockReferenceIterator`
    Return the next CodeBlockReference.
    Specified by:
      `next` in interface `CodeBlockReferenceIterator`
    Throws:
      `CancelledException` - thrown if the operation is cancelled.
    See Also:
      - `CodeBlockReferenceIterator.next()`

  - ### hasNext

    public boolean hasNext() throws CancelledException
    Description copied from interface: `CodeBlockReferenceIterator`
    Return true if next() will return a CodeBlockReference.
    Specified by:
      `hasNext` in interface `CodeBlockReferenceIterator`
    Throws:
      `CancelledException` - thrown if the operation is cancelled.
    See Also:
      - `CodeBlockReferenceIterator.hasNext()`

  - ### getNumDestinations

    @Deprecated public static int getNumDestinations(CodeBlock block, boolean followIndirectFlows, TaskMonitor monitor) throws CancelledException
    Deprecated.
    this method should be avoided since it repeats the work of the iterator
    Get number of destination references flowing out of this block. All Calls from this block, and all external FlowType block references from this block are ignored.
    Parameters:
      `block` - code block to get the number of destination references from.
      `followIndirectFlows` - indirect references will only be included if true
      `monitor` - task monitor which allows user to cancel operation.
    Throws:
      `CancelledException` - if the monitor cancels the operation.